function updateAxes

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

if plottingData(1).nDiagramsChanged
    run switchVisibilityUIcontrols
    plottingData(1).nDiagramsChanged = false;
end

if plottingData(1).nDiagrams < 2 || plottingData(1).beingAdjusted
    set(handles.checkbox1,'Enable','off')
    set(handles.checkbox2,'Enable','off')
    set(handles.checkbox1,'Value',0)
    set(handles.checkbox2,'Value',0)
    plottingData(1).makeSampling = false;
    plottingData(1).plotAverage = false;
    plottingData(1).plotFill = false;
else
    set(handles.checkbox1,'Enable','on')
    set(handles.checkbox2,'Enable','on')
end
    
% diagram adjustment
if plottingData(1).beingAdjusted
    % data smoothing
    plottingData(plottingData(1).currentDiagram).unSampledData =...
        [smooth(plottingData(plottingData(1).currentDiagram).multiplierX*plottingData(plottingData(1).currentDiagram).originalData(:,plottingData(1).colX),...
        0.015*plottingData(plottingData(1).currentDiagram).smoothing),...
        smooth(plottingData(plottingData(1).currentDiagram).multiplierY*plottingData(plottingData(1).currentDiagram).originalData(:,plottingData(1).colY),...
        0.015*plottingData(plottingData(1).currentDiagram).smoothing)];
    plottingData(1).justAdjusted = true;

    % shape adjustment
    if plottingData(1).shapeChanged
        dx = abs(plottingData(plottingData(1).currentDiagram).markerLow(1)-...
            plottingData(plottingData(1).currentDiagram).markerHigh(1));
        dy = abs(plottingData(plottingData(1).currentDiagram).markerLow(2)-...
            plottingData(plottingData(1).currentDiagram).markerHigh(2));
        k = dy/dx;
        q = plottingData(plottingData(1).currentDiagram).markerLow(2)-...
            k*plottingData(plottingData(1).currentDiagram).markerLow(1);
        xOffset = -q/k;
        
        % stiffness
        plottingData(plottingData(1).currentDiagram).unSampledData =...
            plottingData(plottingData(1).currentDiagram).unSampledData(plottingData(1).lowIndex:end,:);
        plottingData(plottingData(1).currentDiagram).unSampledData(:,1) =...
            plottingData(plottingData(1).currentDiagram).unSampledData(:,1)-xOffset;
        plottingData(plottingData(1).currentDiagram).unSampledData =...
            [0,0;plottingData(plottingData(1).currentDiagram).unSampledData];
        
        % end crop
        entriesToEliminate = length(plottingData(plottingData(1).currentDiagram).temporaryDiagrams)-plottingData(1).endIndex;
        plottingData(plottingData(1).currentDiagram).unSampledData =...
            plottingData(plottingData(1).currentDiagram).unSampledData(1:end-entriesToEliminate,:);
    end
end

% make the array of adjusted data
if plottingData(1).justAdjusted
    plottingData(plottingData(1).currentDiagram).adjustedData =...
        plottingData(plottingData(1).currentDiagram).unSampledData;
    plottingData(1).justAdjusted = false;
end

% data sampling
if plottingData(1).makeSampling
    for i = 1:plottingData(1).nDiagrams
        plottingData(i).sampledData =...
            curveSampling([plottingData(i).adjustedData(:,1),plottingData(i).adjustedData(:,2)],...
            plottingData(1).samplingDensity);
    end
end  

% calculate mean
if plottingData(1).plotAverage
    plottingData(1).averageData = zeros(size(plottingData(1).sampledData));
    for i = 1:plottingData(1).nDiagrams
        plottingData(1).averageData = plottingData(1).averageData+plottingData(i).sampledData;
    end
    plottingData(1).averageData = plottingData(1).averageData/plottingData(1).nDiagrams;
end

% calculate statistical data
if plottingData(1).exportData
    statisticalDataDiagrams = zeros(plottingData(1).nDiagrams,4); % max Y | X @ max Y | area | max X
    for j = 1:plottingData(1).nDiagrams
        [statisticalDataDiagrams(j,1), maxYposition] = max(plottingData(j).adjustedData(:,2));
        statisticalDataDiagrams(j,2) = plottingData(j).adjustedData(maxYposition,1);
        statisticalDataDiagrams(j,3) = trapz(plottingData(j).adjustedData(:,1),plottingData(j).adjustedData(:,2));
        statisticalDataDiagrams(j,4) = max(plottingData(j).adjustedData(:,1));
    end
    averageValues = mean(statisticalDataDiagrams);
    standardDeviations = std(statisticalDataDiagrams);
    coeffOfVariation = standardDeviations./averageValues*100;
    
    run exportData
    plottingData(1).exportData = false;
end

% calculate fill
if plottingData(1).plotFill
    minLength = 0;
    for i = 1:plottingData(1).nDiagrams
        if i == 1
            minLength = plottingData(i).sampledData(end,1);
        end
        minLength = min(minLength, plottingData(i).sampledData(end,1));
    end
    xPoints = linspace(0,minLength,plottingData(1).samplingDensity);
    xPoints = xPoints';
    
    plottingData(1).fillMin = zeros(plottingData(1).samplingDensity,2);
    plottingData(1).fillMax = zeros(plottingData(1).samplingDensity,2);
    plottingData(1).fillMin(:,1) = xPoints;
    plottingData(1).fillMax(:,1) = xPoints;
    for i = 1:plottingData(1).nDiagrams
        yPoints = interp1(unique(plottingData(i).sampledData(:,1)),plottingData(i).sampledData(1:length(unique(plottingData(i).sampledData(:,1))),2),xPoints);
        if i == 1
            plottingData(1).fillMin(:,2) = yPoints;
            plottingData(1).fillMax(:,2) = yPoints;
        end
        plottingData(1).fillMin(:,2) = min(yPoints,plottingData(1).fillMin(:,2));
        plottingData(1).fillMax(:,2) = max(yPoints,plottingData(1).fillMax(:,2));
    end
end

if plottingData(1).plotFigure
    if plottingData(1).printLayout == 2
        printFig = figure('Units', 'pixels', 'Position', [100 100 800 425]);
    else
        printFig = figure('Units', 'pixels', 'Position', [100 100 400 425]);
    end
    axesToPlot = axes;
else
    axesToPlot = handles.axes1;
end

% plotting the data
if plottingData(1).beingAdjusted
    for i = 1:plottingData(1).nDiagrams
        if i == plottingData(1).currentDiagram
            
            % original curve
            plot(axesToPlot,...
                plottingData(i).temporaryDiagrams(:,1),plottingData(i).temporaryDiagrams(:,2),...
                '--','LineWidth',1.5,'Color',[0.7,0.7,0.7])
            hold on
            
            % adjusted curve
            plot(axesToPlot,...
                plottingData(i).adjustedData(:,1),plottingData(i).adjustedData(:,2),...
                plottingData(i).lineType,'LineWidth',1.5,'Color',plottingData(i).lineColor/255)
            
            % stiffness markers
            if ~plottingData(1).shapeChanged
                plot(axesToPlot,...
                    [plottingData(plottingData(1).currentDiagram).markerLow(1),plottingData(plottingData(1).currentDiagram).markerHigh(1)],...
                    [plottingData(plottingData(1).currentDiagram).markerLow(2),plottingData(plottingData(1).currentDiagram).markerHigh(2)],...
                    'o','LineWidth',2,'MarkerSize',12,'MarkerEdgeColor',[0.7,0.7,0.7])
                text(plottingData(plottingData(1).currentDiagram).markerLow(1),plottingData(plottingData(1).currentDiagram).markerLow(2),...
                    'P1  ','HorizontalAlignment','right','VerticalAlignment','bottom','FontWeight','bold','Color',[0.7,0.7,0.7])
                text(plottingData(plottingData(1).currentDiagram).markerHigh(1),plottingData(plottingData(1).currentDiagram).markerHigh(2),...
                    'P2  ','HorizontalAlignment','right','VerticalAlignment','bottom','FontWeight','bold','Color',[0.7,0.7,0.7])
                plot(axesToPlot,...
                    [plottingData(plottingData(1).currentDiagram).markerEnd(1),plottingData(plottingData(1).currentDiagram).markerEnd(1)],...
                    [plottingData(plottingData(1).currentDiagram).markerEnd(2),plottingData(plottingData(1).currentDiagram).markerEnd(2)],...
                    'x','LineWidth',2,'MarkerSize',14,'MarkerEdgeColor',[0.7,0.7,0.7])
                text(plottingData(plottingData(1).currentDiagram).markerEnd(1),plottingData(plottingData(1).currentDiagram).markerEnd(2),...
                    'End  ','HorizontalAlignment','right','VerticalAlignment','bottom','FontWeight','bold','Color',[0.7,0.7,0.7])
            else
                plot(axesToPlot,...
                    [plottingData(plottingData(1).currentDiagram).markerLow(1),plottingData(plottingData(1).currentDiagram).markerHigh(1)],...
                    [plottingData(plottingData(1).currentDiagram).markerLow(2),plottingData(plottingData(1).currentDiagram).markerHigh(2)],...
                    '-or','LineWidth',2,'MarkerSize',12,'MarkerEdgeColor','r')
                text(plottingData(plottingData(1).currentDiagram).markerLow(1),plottingData(plottingData(1).currentDiagram).markerLow(2),...
                    'P1  ','HorizontalAlignment','right','VerticalAlignment','bottom','FontWeight','bold','Color','r')
                text(plottingData(plottingData(1).currentDiagram).markerHigh(1),plottingData(plottingData(1).currentDiagram).markerHigh(2),...
                    'P2  ','HorizontalAlignment','right','VerticalAlignment','bottom','FontWeight','bold','Color','r')
                plot(axesToPlot,...
                    [plottingData(plottingData(1).currentDiagram).markerEnd(1),plottingData(plottingData(1).currentDiagram).markerEnd(1)],...
                    [plottingData(plottingData(1).currentDiagram).markerEnd(2),plottingData(plottingData(1).currentDiagram).markerEnd(2)],...
                    'x','LineWidth',2,'MarkerSize',14,'MarkerEdgeColor','r')
                text(plottingData(plottingData(1).currentDiagram).markerEnd(1),plottingData(plottingData(1).currentDiagram).markerEnd(2),...
                    'End  ','HorizontalAlignment','right','VerticalAlignment','bottom','FontWeight','bold','Color','r')
            end
        else
            plot(axesToPlot,...
                plottingData(i).adjustedData(:,1),plottingData(i).adjustedData(:,2),...
                plottingData(i).lineType,'LineWidth',1,'Color',[0.8,0.8,0.8])
        end
        hold on
    end
    plottingData(1).shapeChanged = false;
elseif plottingData(1).plotFill 
    hold off
    fillX = [plottingData(1).fillMin(:,1)', fliplr(plottingData(1).fillMax(:,1)')];
    fillY = [plottingData(1).fillMin(:,2)', fliplr(plottingData(1).fillMax(:,2)')];
    fill(fillX,fillY,plottingData(1).fillColor/255,'facealpha',0.5);
    hold on
else
    for i = 1:plottingData(1).nDiagrams
        plot(axesToPlot,...
            plottingData(i).adjustedData(:,1),plottingData(i).adjustedData(:,2),...
            plottingData(i).lineType,'LineWidth',1.5,'Color',plottingData(i).lineColor/255)
        hold on
    end
end

if plottingData(1).plotAverage
    plot(axesToPlot,...
        plottingData(1).averageData(:,1),plottingData(1).averageData(:,2),...
        '-','LineWidth',2.5,'Color',plottingData(1).averageColor/255)
end
hold off

if plottingData(1).plotLegend
    plottingData(1).legendEntries = plottingData(1).fileNames;
    if plottingData(1).plotFill
        plottingData(1).legendEntries = cell(1,1);
        plottingData(1).legendEntries{1} = 'range';
    end
    if plottingData(1).plotAverage
        plottingData(1).legendEntries = [plottingData(1).legendEntries,'mean'];
    end
    if plottingData(1).legendLocationNumber == 7 || plottingData(1).legendLocationNumber == 8 || plottingData(1).legendLocationNumber == 11 || plottingData(1).legendLocationNumber == 12
        hLegend = legend(axesToPlot,plottingData(1).legendEntries,'Location',plottingData(1).legendLocation,'Orientation','horizontal','Interpreter','LaTex','FontSize',11);
    else
        hLegend = legend(axesToPlot,plottingData(1).legendEntries,'Location',plottingData(1).legendLocation,'Interpreter','LaTex','FontSize',11);
    end  
end

if plottingData(1).autoscaleX
    xLimit = get(axesToPlot,'xLim');
    set(handles.edit19,'String',num2str(xLimit(1)))
    set(handles.edit20,'String',num2str(xLimit(2)))
else
    set(axesToPlot,'xLim',[str2double(get(handles.edit19,'String')),str2double(get(handles.edit20,'String'))])
end

if plottingData(1).autoscaleY
    yLimit = get(axesToPlot,'yLim');
    set(handles.edit23,'String',num2str(yLimit(1)))
    set(handles.edit24,'String',num2str(yLimit(2)))
else
    set(axesToPlot,'yLim',[str2double(get(handles.edit23,'String')),str2double(get(handles.edit24,'String'))])
end

xLabel = xlabel(plottingData(1).xLabel,'Interpreter','LaTex','FontSize',11);
yLabel = ylabel(plottingData(1).yLabel,'Interpreter','LaTex','FontSize',11);
if plottingData(1).plotGrid
   set(axesToPlot,'Box','on','TickDir','out','TickLength',[.02,.02],...
       'XMinorTick','on','YMinorTick','on','YGrid','on','XGrid','on')
else
   set(axesToPlot,'Box','on','TickDir','out','TickLength',[.02,.02],...
       'XMinorTick','on','YMinorTick','on','YGrid','off','XGrid','off')
end

if plottingData(1).plotFigure
    % increase space between axes and the axes labels
    set(xLabel,'position',get(xLabel,'position')-[0 0.01 0])
    set(yLabel,'position',get(yLabel,'position')-[0.01 0 0])
    
    % adjust spacing within the figure
    if plottingData(1).legendLocationNumber == 9 || plottingData(1).legendLocationNumber == 10 % East and West Outside
        if plottingData(1).printLayout == 2
            set(axesToPlot, 'Position',[0.1 0.14 0.75 0.8])
        else
            set(axesToPlot, 'Position',[0.16 0.14 0.55 0.8])
        end
    elseif plottingData(1).legendLocationNumber == 11 || plottingData(1).legendLocationNumber == 12 % North and South Outside
        if plottingData(1).printLayout == 2
            set(axesToPlot, 'Position',[0.1 0.14 0.8 0.75])
        else
            set(axesToPlot, 'Position',[0.16 0.14 0.8 0.75])
        end
    else % the legend is inside
        if plottingData(1).printLayout == 2
            set(axesToPlot, 'Position',[0.1 0.14 0.85 0.8])
        else
            set(axesToPlot, 'Position',[0.16 0.14 0.8 0.8])
        end
    end

    folderName = plottingData(1).projectName;
    exportFolderName = strcat('output/',folderName);
    fileNameDiagrams = [exportFolderName,'/',folderName,'-diagrams'];
    
    if ~isequal(exist(exportFolderName,'dir'),7) % check whether the destination folder exists
        mkdir(strcat(pwd,'/output'),char(folderName))
    end
    
    set(printFig,'PaperPositionMode','auto')
    print(printFig,fileNameDiagrams,'-depsc','-tiff')
    set(hLegend,'string',strcat(get(hLegend,'string'),'\quad')); % appends quad to each string
    print(printFig,fileNameDiagrams,'-dpng')
    hMsgBox = msgbox('Figure saved successfuly.');
    pause(1.5)
    close(hMsgBox)
    close(printFig)
    
    plottingData(1).plotFigure = false;
end

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

end